#include <iostream>
#include "UciParser.h"
#include "ChessGame.h"
#include "MoveGeneration.h"

using namespace std;
using namespace chessy;

auto main(int argc, char** argv) -> int
{
    UciParser uciParser;
    uciParser.parse(cin, cout);
    return 0;


    ChessGame cg;
    string line;
    getline(cin, line);
    try {
        cg.loadFromFen(line);
        cout << cg.generateFen() << endl;

        Bitboard whites = cg.getBoard().getWhites();
        Bitboard blacks = cg.getBoard().getBlacks();
        
        PawnPushGenerator<BLACK_SIDE> mg{ cg };
        for (auto push : mg) {
            cout << "pawn: " << push.asString() << endl;
        }
        PositionSet knights = cg.getBoard().getBlackKnights();
        for (auto knight : knights) {
            for (auto pos : KnightMoveGenerator{ knight, blacks }) {
                cout << "knight: " << Move(knight, pos).asString() << endl;
            }
        }

        PositionSet bishops = cg.getBoard().getBlackBishops();
        for (auto bishop : bishops) {
            for (auto pos : PrimitiveBishopMoveGenerator{ bishop, whites, blacks }) {
                cout << "bishop: " << Move(bishop, pos).asString() << endl;
            }
        }

        PositionSet rooks = cg.getBoard().getBlackRooks();
        for (auto rook : rooks) {
            for (auto pos : PrimitiveRookMoveGenerator{ rook, whites, blacks }) {
                cout << "rook: " << Move(rook, pos).asString() << endl;
            }
        }

        PositionSet queens = cg.getBoard().getBlackQueens();
        for (auto queen : queens) {
            for (auto pos : PrimitiveQueenMoveGenerator{ queen, whites, blacks }) {
                cout << "queen: " << Move(queen, pos).asString() << endl;
            }
        }

        Bitboard king = cg.getBoard().getBlackKings();
        Index kingIndex = king.getLeastSignificantBit();
        for (auto pos : KingMoveGenerator{ king, blacks }) {
            cout << "king: " << Move(kingIndex, pos).asString() << endl;
        }
    }
    catch (runtime_error& re) {
        cerr << re.what() << endl;
        return 1;
    }
    return 0;
}
